<?php
/*
Plugin Name: ManagedOrg Donative
Plugin URI: https://wordpress.org/plugins/managedorg-product-driver/
Description: Managedorg Product Driver for Amazon Business Integration.
Version: 1.0.7.9
Author: Managedorg
Author URI: https://managedorg.io/ 
 */
if (!defined('ABSPATH')) die('No direct access allowed');
	
if (!class_exists('MODD_Donation')) :
define('MODD_VERSION', '1.0.7.9');
define('MODD_PLUGIN_URL', plugin_dir_url(__FILE__));
define('MODD_PLUGIN_MAIN_PATH', plugin_dir_path(__FILE__));

class MODD_Donation {
	public $location 	= '';
	public $tags		= '';
	public $colors 	= array(
		'background_color'   => '#FFFFFF',
		'foreground_color'   => '#b1208a',
		'button_color'   => '#b1208a',
		'wishlist_color' => '#FFFFFF',
		'product_background' => '#FFFFFF',
		'payment_mode' => 'test',
		'campaign_title_color'=>'#b1208a',
		'campaign_header'=>'#b1208a'
		
	);

	

	/**
	 * Class constructor
	 */
	public function __construct() {
		add_action('plugins_loaded', array($this, 'plugins_loaded'), 1);
		// add_action('wp_enqueue_scripts', array($this, 'modd_enqueue_scripts'), 15);
		add_action( 'admin_enqueue_scripts', array($this, 'modd_plugin_scripts'),9 );
		$this->modd_shortcode();
		add_action( 'admin_menu', array($this,'modd_admin_menu'));
		register_activation_hook( __FILE__, array($this,'modd_activate'));
		add_action( 'admin_footer', array($this,'modd_color_picker'));
		
	}

	public function plugins_loaded() {
		$this->get_default_colors();
	
	}

	public function get_default_colors() {
		$colors_up = get_option('modd_color_options');
		if (empty($colors_up)) {
			$colors_up 	= $this->colors;
		}
		$fgColor 		= $colors_up['foreground_color'];
		$bgColor 		= $colors_up['background_color'];
		$btnColr 		= $colors_up['button_color'];
		$wishlistColor 	= $colors_up['wishlist_color'];
		$productColor 	= $colors_up['product_background'];
		$campaign_title_color = $colors_up['campaign_title_color'];
		$campaign_header = $colors_up['campaign_header'];
		return $colors_up;
	}

	public function get_payment_mode() {
		$colors_up = $this->get_default_colors();
		if(!array_key_exists("payment_mode",$colors_up) || $colors_up['payment_mode'] == '') {
			$colors_up['payment_mode'] = 'test';
		}
		return $colors_up['payment_mode'];
	}
	
	public function modd_frontend_enqueue_scripts_styles() {
		wp_enqueue_script('jquery');
		wp_enqueue_style('modd_slick_theme', plugins_url('/css/slick-theme.css', __FILE__), array(), MODD_VERSION); 
		wp_enqueue_style('modd_slick_css', plugins_url('/css/slick.css', __FILE__), array(), MODD_VERSION); 
		wp_enqueue_style('modd_bootstrap_css', plugins_url('/css/bootstrap.min.css', __FILE__), array(), MODD_VERSION); 
		wp_enqueue_style('modd_simplePagination', plugins_url('/css/simplePagination.min.css', __FILE__), array(), MODD_VERSION); 
		wp_enqueue_style('modd_font_awesome', plugins_url('/css/font-awesome.min.css', __FILE__), array(), MODD_VERSION); 
		wp_enqueue_style('modd_style', plugins_url('/css/modd_style.css', __FILE__), array(), MODD_VERSION); 
		wp_enqueue_style('modd_toastr', plugins_url('/css/toastr.min.css', __FILE__), array(), MODD_VERSION); 
		wp_enqueue_style('modd_payment', 'https://admin.managedorg.io/assets/css/payment.css', array(), MODD_VERSION);

		
		wp_enqueue_script('modd_jqery', 'https://code.jquery.com/jquery-3.2.1.min.js', array(), MODD_VERSION, true);
		wp_enqueue_script('modd_axios', plugins_url('/js/axios.min.js', __FILE__), array(), MODD_VERSION, true); 
		wp_enqueue_script('modd_bootstrap', plugins_url('/js/bootstrap.bundle.min.js', __FILE__), array(), MODD_VERSION, true); 
		wp_enqueue_script('modd_pagination', plugins_url('/js/jquery.simplePagination.min.js', __FILE__), array(), MODD_VERSION, true); 
		wp_enqueue_script('modd_slick', plugins_url('/js/slick.min.js', __FILE__), array(), MODD_VERSION, true); 
		wp_enqueue_script('modd_toastr', plugins_url('/js/toastr.min.js', __FILE__), array(), MODD_VERSION, true);
		wp_enqueue_script('modd_main_payment_internal', plugins_url('/js/payment-internal.js', __FILE__), array(), MODD_VERSION, true);
		
		if (strpos($_SERVER['HTTP_HOST'], 'catholiccharities') !== false) {
			wp_enqueue_script('modd_bootstrap-1', 'https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js', array(), MODD_VERSION, true);
		}
		
		wp_enqueue_script('modd_main_payment', plugins_url('/js/payments-donative.js', __FILE__), array(), MODD_VERSION, true);
		//wp_enqueue_script('modd_main_payment', 'https://admin.managedorg.io/assets/js/payments-donative.js', array(), MODD_VERSION, true);

		wp_enqueue_script('modd_main', plugins_url('/js/modd_myscript.js', __FILE__), array(), MODD_VERSION, true);
		wp_localize_script('modd_main', 'mood_main_parameters',
			array(
				'modd_payment_mode' => $this->get_payment_mode(),

			)
		);
	}

	public function modd_shortcode(){
		add_shortcode('MODD_SLIDER', array($this,'modd_product_slider'));
		add_shortcode('MODD_LIST', array($this,'modd_product_list'));
	}

	function modd_product_slider($atts){
		global $post;
		global $location;
		global $tags;
		$this->modd_frontend_enqueue_scripts_styles();
		add_action( 'wp_footer', array($this,'modd_my_footer_scripts'), 30);
		$colors_up = $this->get_default_colors();
		$fgColor = $colors_up['foreground_color'];
		$bgColor = $colors_up['background_color'];
		$btnColr = $colors_up['button_color'];
		$campaign_title_color = $colors_up['campaign_title_color'];
		$campaign_header = $colors_up['campaign_header'];
		$current_id = $post->ID;
		$campaign_id = '';
		$campaign_type = '';
		$server = '';
		$admin = '';
		$origin = '';

		$a = shortcode_atts( array(
			'ids' => '',
			'fgcolor' => '',
			'bgcolor' => '',
			'featured' => 'false',
			'location' => '',
			'tags' => '',
			'anonymous'=> '',
			'campaign_id'=>'',
			'campaign_type'=>'',
			'server'=>'',
			'admin'=>'',
			'origin'=>''
		), $atts );

		if($a['fgcolor'] != ''){
			$fgColor = esc_attr($a['fgcolor']);
			$btnColr = $fgColor;
		}
		

		$isFP 			= is_front_page();
		$pageIdArray	= explode(',', esc_attr($a['ids']));
		$location		= esc_attr($a['location']);

		if($a['tags'] != ''){
			$tags			= esc_attr($a['tags']);
		}

		$myContent 		= '';

		$myContent		.= '<style> #modd_opener{display:none;} </style>';
		if((in_array($current_id, $pageIdArray))){
			$featuredString = '';
			if($a['featured'] == 'true'){
				$myContent .= '<div class="modd_h4" style="margin-bottom: 10px;margin-left:15px;">Featured Products</div>';
				$featuredString = '-featured';
			}
			else{
				$featuredString = '';
			}

			$myContent .= '<!--Slick Carousel Slider-->
			<div class="modd_items" style="max-width: 100%; margin-top: 10px;" id="modd_scroll_product_list'.$featuredString.'"></div>';

			$myContent .= '<div class="modal fade" id="productDetailModalSlider'.$featuredString.'" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel'.$featuredString.'" aria-hidden="true" style="max-width: unset;">
			<div class="modal-dialog" role="document">
				<div class="modal-content">
				<div class="modal-header">
					<div class="modal-title modd_h5" id="exampleModalLabel'.$featuredString.'">New message</div>
					<button type="button" class="close btn btn-primary" data-bs-dismiss="modal" aria-label="Close">
					<span aria-hidden="true">&times;</span>
					</button>
				</div>
				<div class="modal-body">
					<div>
						<div style="display:block;width:100%;text-align:center;" id="pImageInDetSlider'.$featuredString.'">
						</div>
						<div style="display:block;width:100%;"><span id="pNameInDetSlider'.$featuredString.'"></span></div>
						<ul id="pFeaturesInDetSlider'.$featuredString.'"></ul>
					</div>
				</div>
				<div class="modal-footer">
					<label class="form-control-sm">Quantity : </label><select class="form-control form-control-sm" style="margin-left: 0; width:100px;" id="modd_selQuantity_slide'.$featuredString.'"></select>
					<input type="hidden" id="hiddenASINOnPModal'.$featuredString.'" value="">
					<input type="hidden" id="modd_p_image_slide'.$featuredString.'" value="">
					<input type="hidden" id="modd_p_name_slide'.$featuredString.'" value="">
					<input type="hidden" id="modd_p_amount_slide'.$featuredString.'" value="">
					<input type="hidden" id="modd_p_currency_slide'.$featuredString.'" value="">
					<input type="hidden" id="modd_p_id_slide'.$featuredString.'" value="">
					<input type="hidden" id="modd_camp_req_id_slide'.$featuredString.'" value="">
					<input type="hidden" id="modd_camp_id_slide'.$featuredString.'" value="">
					<input type="hidden" id="modd_max_quantity_slide'.$featuredString.'" value="">
					<button type="button" class="btn btn-primary btn-sm" id="pBtnCartInDetSlider'.$featuredString.'"><i class="fa fa-shopping-cart"></i> Add To Cart</button>
				</div>
				</div>
			</div>
			</div>';


			$myContent		.= '<style>'.
				'#modd_shoppingcart_btn, #modd_cart_content {color:'.$fgColor.';}'.
				'#modd_opener{ display:block;}'.
				'#modd_campaign_list_div .btn-modd { color: #fff; background-color: '.$btnColr.'; border-color: '.$btnColr.'; text-transform: none; }'.
				'#modd_campaign_list_div .btn-modd:hover { color: #fff; background-color: '.$btnColr.' !important; border-color: '.$btnColr.'; }'.
				'#modd_campaign_list_div .btn-modd:focus { color: #fff; background-color: '.$btnColr.' !important; border-color: '.$btnColr.'00; }'. 
				'#modd_campaign_list_div .light-theme .current { background-color: '.$btnColr.'; border-color: '.$btnColr.'99; }'.
			'</style>';
			if($a['anonymous'] == 'off') {
			?>
				<script>
				window.addEventListener('load', function() {
					element = document.getElementById('modd-chk-anonymous');
					element.remove()
				});
				</script>
			<?php
			}
		}

		
		//$jsonData = '{"pluginUrl":"'.plugins_url().'", "location":"'.$location.'", "tags":"'.$tags.'", "fgcolor":"'.$colors_up['foreground_color'].'", "bgcolor":"'.$colors_up['background_color'].'"}';
		$jsonData = '';
		//$myContent .= '<div id="moddTagValuesSlider" style="display:none;visibility:hidden;height:0px;width:0px;">'.$tags.'</div>';
		$myContent .= '<div id="moddTagValuesSlider" style="display:none;visibility:hidden;height:0px;width:0px;">'.$jsonData.'</div>';
		

		return $myContent;
	}
	

	function modd_product_list($atts){
		global $post;
		global $tags;
		global $location;
		$this->modd_frontend_enqueue_scripts_styles();
		add_action( 'wp_footer', array($this,'modd_my_footer_scripts'), 30);
		$colors_up = $this->get_default_colors();
		$fgColor = $colors_up['foreground_color'];
		$bgColor = $colors_up['background_color'];
		$btnColr = $colors_up['button_color'];
		$wishlistColor = $colors_up['wishlist_color'];
		$productColor =  $colors_up['product_background'];
		$campaign_title_color = $colors_up['campaign_title_color'];
		$campaign_header = $colors_up['campaign_header'];
		$current_id = $post->ID;
		$campaign_id = '';
		$campaign_type = '';
		$server = '';
		$admin = '';
		$origin = '';
		$shipping = 1;
		$blocked_campaign ='';
		$products_per_page ='';
		$campaigns_per_page ='';
		$cart_checkbox ='';
		$helpwith_checkbox_text ='';
		$helpwith_label ='';
		$helpwith_description ='';
		$priority_first = '';
		$helpwith_enable = '';
		
		$a = shortcode_atts( array(
			'ids' => '',
			'productTemplate' => 'card',
			'fgcolor' => '',
			'bgcolor' => '',
			'location' => '',
			'tags' => '',
			'anonymous'=> '',
			'campaign_id'=>'',
			'campaign_type'=>'',
			'server'=>'',
			'admin'=>'',
			'origin'=>'',
			'payment_mode'=>'',
			'shipping'=>'',
			'blocked_campaign'=>'',
			'products_per_page'=>'',
			'campaigns_per_page'=>'',
			'cart_checkbox'=>'',
			'helpwith_checkbox_text'=>'',
			'helpwith_label'=>'',
			'helpwith_description'=>'',
			'priority_first'=>'',
			'helpwith_enable'=>''
			
		), $atts );

		if($a['fgcolor'] != ''){
			$fgColor = esc_attr($a['fgcolor']);
			$btnColr = $fgColor;
		}

		$pageIdArray	= explode(',', esc_attr($a['ids']));
		$location		= esc_attr($a['location']);

		if($a['tags'] != ''){
			$tags			= esc_attr($a['tags']);
		}
		if($a['campaign_id'] != ''){
			$campaign_id = esc_attr($a['campaign_id']);
		}
		if($a['campaign_type'] != ''){
			$campaign_type = esc_attr($a['campaign_type']);
		}
		if($a['server'] != ''){
			$server			= esc_attr($a['server']);
		}
		if($a['admin'] != ''){
			$admin = esc_attr($a['admin']);
		}
		if($a['origin'] != ''){
			$origin = esc_attr($a['origin']);
		}
		if($a['payment_mode'] == 'production' || $a['payment_mode'] == 'test'){
			wp_localize_script('modd_main', 'mood_main_parameters',
						array(
							'modd_payment_mode' => $a['payment_mode'],

						)
					);
		}
		if($a['shipping'] == 0){
			$shipping = esc_attr($a['shipping']);
		}
		if($a['blocked_campaign'] != ''){
			$blocked_campaign = esc_attr($a['blocked_campaign']);
		}
		if($a['products_per_page'] != ''){
			$products_per_page = esc_attr($a['products_per_page']);
		}
		if($a['campaigns_per_page'] != ''){
			$campaigns_per_page = esc_attr($a['campaigns_per_page']);
		}
		
		if($a['cart_checkbox'] != ''){
			$cart_checkbox = esc_attr($a['cart_checkbox']);
		}
		if($a['helpwith_checkbox_text'] != ''){
			$helpwith_checkbox_text = esc_attr($a['helpwith_checkbox_text']);
		}
		if($a['helpwith_label'] != ''){
			$helpwith_label = esc_attr($a['helpwith_label']);
		}
		if($a['helpwith_description'] != ''){
			$helpwith_description = esc_attr($a['helpwith_description']);
		}
		if($a['priority_first'] != ''){
			$priority_first = esc_attr($a['priority_first']);
		}
		if($a['helpwith_enable'] != ''){
			$helpwith_enable = esc_attr($a['helpwith_enable']);
		}
		$myContent = '';

		if(in_array($current_id, $pageIdArray)){
			$myContent = '<div class="modd_campaign_list_div clearfix" id="modd_campaign_list_div" data-btn_cl ="'.$btnColr.'" data-bg_color = "'.$bgColor.'" data-wishlist_color = "'.$wishlistColor.'" data-productColor = "'.$productColor.'" data-ctitle_color="'.$campaign_title_color.'" data-cheader_color="'.$campaign_header.'" data-anonymous = "'.$a['anonymous'] .'" data-location ="'.$location.'" data-tags ="'.$tags.'" data-campaign_id="'.$campaign_id.'" data-campaign_type="'.$campaign_type.'"  data-server="'.$server.'" data-admin="'.$admin.'" data-origin="'.$origin.'"  data-shipping="'.$shipping.'" data-blocked_campaign="'.$blocked_campaign.'" ';
			
			if (!empty($products_per_page)) { 
				$myContent .= ' data-products_per_page="'.$products_per_page.'"';
			}
			if (!empty($campaigns_per_page)) { 
				$myContent .= ' data-campaigns_per_page="'.$campaigns_per_page.'"';
			}
			if (!empty($cart_checkbox)) { 
				$myContent .= ' data-cart_checkbox="'.$cart_checkbox.'"';
			}
			if (!empty($helpwith_checkbox_text)) { 
				$myContent .= ' data-helpwith_checkbox_text="'.$helpwith_checkbox_text.'"';
			}
			if (!empty($helpwith_label)) { 
				$myContent .= ' data-helpwith_label="'.$helpwith_label.'"';
			}
			if (!empty($helpwith_description)) { 
				$myContent .= ' data-helpwith_description="'.$helpwith_description.'"';
			}
			if (!empty($priority_first)) { 
				$myContent .= ' data-priority_first="'.$priority_first.'"';
			}
			if (!empty($helpwith_enable) || $helpwith_enable ==0) { 
				$myContent .= ' data-helpwith_enable="'.$helpwith_enable.'"';
			}
			
			$myContent.='>';
			$myContent.='<ul class="results wrapper modd_campaign_list_ul" style="background-color:'.$bgColor.'" id="modd_campaign_list">
				</ul>
				<div id="camp_pagination"></div>
			</div>';

			$myContent		.= '<style>'.
				'#modd_shoppingcart_btn, #modd_cart_content {color:'.$fgColor.';}'.
				'#modd_opener{ display:block; }'.
				'#modd_campaign_list_div .btn-modd { color: #fff; background-color: '.$btnColr.'; border-color: '.$btnColr.'; text-transform: none;}'.
				'#modd_campaign_list_div .btn-modd:hover { color: #fff; background-color: '.$btnColr.' !important; border-color: '.$btnColr.'; }'.
				'#modd_campaign_list_div .btn-modd:focus { color: #fff; background-color: '.$btnColr.' !important; border-color: '.$btnColr.'99; }'.
				'#modd_campaign_list_div .light-theme .current { background-color: '.$btnColr.'; border-color: '.$btnColr.'99; }'.
			'</style>';
			
		}

		return $myContent;
	}

	
    
	function modd_my_footer_scripts() { 
		global $btnColr;
		ob_start();
	?>
	<style>.fa.fa-trash:before { content: "\f1f8";}</style>
		<div id="modd_slide-panel" style="display:block;" data-plugin_url="<?php echo MODD_PLUGIN_URL;?>" data-plugin_version="<?php echo MODD_VERSION;?>">
			<a href="#" class="btn-modd modd_opener" id="modd_opener">
				<span class="badge text-bg-primary text-white" style="position: absolute;top: 3px;left: 3px;padding: 0.1em 0.3em;font-size: 11px;font-weight: 600; display:none;" id="modd_cart_item_count">0</span>
				<div class="modd_cart_img"></div>
			</a>
		<div>
			<div style="font-weight:600; font-size:24px;" id="modd_shoppingcart_btn">
				<img style="width: 35px;" src="<?php echo plugins_url('/images/cart_logo.png', __FILE__);?>">
				<span style=""> Cart </span>
				<span id="openerCloseBtn" style="right: 15px; position: absolute; top: 7px;">
					<img style="width: 20px; cursor: pointer;" src="<?php echo plugins_url('/images/delete-sign.png', __FILE__);?>" />
				</span>
			</div>
			<hr style="margin: 5px 0px;" />
			<div id="modd_cart_content" style="font-size: 13px;margin: 0 auto;text-align: center;">
				<img style="width: 250px; max-width: 90%;" src="<?php echo plugins_url('/images/empty-cart.png', __FILE__);?>">
			</div>
	   </div>
	</div>


  <?php
		echo ob_get_clean();
  }

	function modd_set_defualt_options(){
		$options = get_option('modd_color_options');
		if(empty($options)){
			update_option( 'modd_color_options', $this->colors);
		}
	}
	
	function modd_activate() {
		$this->modd_set_defualt_options();
	}

	function modd_plugin_scripts() { 
		wp_enqueue_style( 'wp-color-picker');
		wp_enqueue_script( 'wp-color-picker');
   	}

   	function modd_color_picker() { 
?>
   
	   	<script type="text/javascript">
	   
			jQuery(document).ready(function() {
				jQuery('.modd_color_picker').wpColorPicker();

			});
	   	</script> 
	
<?php
   	}

	public function modd_admin_menu() {
		add_menu_page('ManagedOrg', 'ManagedOrg', 'manage_options', 'maorg_settings',array($this,'maorg_admin_settings'), MODD_PLUGIN_URL.'images/icon.png', 25 );
	}
  
	function maorg_admin_settings(){
		$colors_up = $this->get_default_colors();
		include MODD_PLUGIN_MAIN_PATH . 'lib/admin_settings.php';
	}	

}
endif;
$GLOBALS['modd_donation'] = new MODD_Donation();